//DESCRIPTION:Назначение программы -- распределять выделенные фреймы по вертикали в пропорции чисел Фибоначчи (5  8  13  21  34  55 ...). С её помощью можно, например, гармонично разместить на титуле название книги и имя автора. Гармония в данном случае заключается в том, что отношение высот соседних свободных полей близко к пропорции золотого сечения. Работает в версиях программ CS3-CS5. Среди выделенных объектов не должно быть групп фреймов. Если среди выделенных объектов нет зафиксированных объектов,  то выделенные фреймы пропорционально размещаются на странице от верхнего края листа до нижнего. Зафиксированными могут быть или только верхний фрейм, или только нижний, или оба этих фрейма. Если зафиксирован верхний фрейм, то свободное пространство размещения остальных фреймов — от нижней границы этого фрейма до низа листа. Если зафиксирован нижний фрейм, то  свободное пространство размещения остальных фреймов — от верха листа до верхней границы этого фрейма. Если закреплены верхний и нижний фреймы, то свободное пространство ограничено нижней гранью верхнего фрейма и верхней гранью нижнего. Эти закрепленные верхний и нижний фреймы могут быть служебными фреймами, только на время работы этого скрипта,  искусственно ограничивающими свободное пространство, если, например, на титуле есть какое-то графическое оформление сверху/снизу полосы,  и надо красиво разместить заголовок в оставшемся белом поле. Особенности использования скрипта в версии CS5: В этой версии по умолчанию запрещено помещать в выборку зафиксированные объекты.  Чтобы пользоваться скриптом, этот запрет надо снять -- вкладка Preferences => окно General -- > поле Object Editing : снять флажок строки Prevent Selection of Locked Objects.

// RightBookTitul.jsx 
// © Михаил Иванюшин, 2011 ivanyushin#yandex.ru
//
// 11 / 07 / 2011
//
/*
Назначение программы -- распределять выделенные фреймы по вертикали в пропорции чисел Фибоначчи (5  8  13  21  34  55 ...).
С её помощью можно, например, гармонично разместить на титуле название книги и имя автора.
Гармония в данном случае заключается в том, что отношение высот соседних свободных полей близко к пропорции золотого сечения.
Работает в версиях программ CS3-CS5.
Среди выделенных объектов не должно быть групп фреймов.
Если среди выделенных объектов нет зафиксированных объектов, 
то выделенные фреймы пропорционально размещаются на странице от верхнего края листа до нижнего.
Зафиксированными могут быть или только верхний фрейм, или только нижний, или оба этих фрейма.
Если зафиксирован верхний фрейм, то свободное пространство размещения остальных фреймов — от нижней границы этого фрейма до низа листа.
Если зафиксирован нижний фрейм, то  свободное пространство размещения остальных фреймов — от верха листа до верхней границы этого фрейма.
Если закреплены верхний и нижний фреймы, то свободное пространство ограничено нижней гранью верхнего фрейма и верхней гранью нижнего.
Эти закрепленные верхний и нижний фреймы могут быть служебными фреймами, только на время работы этого скрипта, 
искусственно ограничивающими свободное пространство, если, например, на титуле есть какое-то графическое оформление сверху/снизу полосы, 
и надо красиво разместить заголовок в оставшемся белом поле.
Особенности использования скрипта в версии CS5:
В этой версии по умолчанию запрещено помещать в выборку зафиксированные объекты. 
Чтобы пользоваться скриптом, этот запрет надо снять -- вкладка Preferences => окно General -- > поле Object Editing : снять флажок строки Prevent Selection of Locked Objects.
------------------------------------------------------------------------------------------------------------------------------------------------------
Пример применения скрипта для гармоничного размещения на титуле названия книги и имени автора:
(эта идея стала отправной точкой написания этой программы)
Строка с именем автора и собственно название книги должны быть в отдельных фреймах. Размеры фреймов должны быть подогнаны к размеру содержимого.
Сперва выделяется фрейм с названием, вызывается скрипт, в результате название книги помещается в оптический центр страницы.
После того, как программа поместит на титуле фрейм с названием книги, надо зафиксировать этот фрейм, выделить фреймы с автором и названием и вновь вызвать скрипт.
Теперь фрейм с именем автора разместится пропорционально в пространстве над заголовком.
*/

var myObjects = new Array; // массив выделенных объектов
var myHeights = new Array; // массив высот выделенных объектов
// ряд чисел Фибоначчи  (0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597, 2584, 4181, 6765, 10946,...)
var myFibNums = [5,8,13,21,34,55,89,144,233];
var myTopY; // координата Y верха страницы
var myBottomY; // координата Y низа страницы, т.к. начало координат в левом верхнем углу, myTopY < myBottomY
var myUnit;
var myNumderOfUnits = 0;
var myTmp;
var myPage;

var mySpace; // свободное пространство по вертикали между текстовыми фреймами
var myX0;
var myX1;
var myY0;
var myY1;
var myNumberOfLockedFrames = 0;

while (myObjects.length != 0) myObjects.pop();
if (app.documents.length == 0) {alert ("Нет открытого документа."); exit();}
var mySelection = app.selection[0];
var myDocument = app.documents[0];
if(app.selection.length == 0)  {alert ("Фреймы не выбраны."); exit();}
if(app.selection.length > 7)  {alert ("Число выбранных фреймов не должно быть больше семи."); exit();}
for (i = 0; i < app.selection.length; i++) { // i
	if (app.selection[i].constructor.name != "TextFrame" && app.selection[i].constructor.name != "Rectangle" || app.selection[i].constructor.name == "Group") {alert ("Работа программы остановлена по следующей причине:\n- или один из выбранных объектов не является фреймом,\n- или в выборку попала группа объектов. Скрипт работает только с несгруппированными фреймами."); exit();}
	myObjects.push(app.selection[i]);
	if (app.selection[i].locked == true)  myNumberOfLockedFrames++;
	} // i
if (myNumberOfLockedFrames > 2) {alert ("Число неперемещаемых фреймов не может быть больше двух."); exit();}
if (((myNumberOfLockedFrames == 1) && (app.selection.length == 1)) || ((myNumberOfLockedFrames == 2) && (app.selection.length == 2))) {alert ("Нет фреймов, которые можно перемещать — \nсовпадает число выделенных и зафиксированных фреймов."); exit();}
myPage = mySelection.parent;
if (parseInt (app.version) < 7) { // CS3, CS4
    myTopY = myPage.bounds[0];
    myBottomY = myPage.bounds[2];
}  // CS3, CS4
else { // CS5
     myTopY = myPage.pages[0].bounds[0];
    myBottomY = myPage.pages[0].bounds[2];
 } // CS5    
// упорядочим выделенные фреймы в порядке возрастания координаты Y (сортировка пузырьком)
myArrayIsSorted = false;
while (myArrayIsSorted == false) { // while
	myArrayIsSorted = true;
	for (i = 0; i < myObjects.length -1;  i++) { // i
		if ((myObjects[i].geometricBounds[0] > myObjects[i + 1].geometricBounds[0])) {
			myTmp = myObjects[i]; 
			myObjects[i] = myObjects[i+1]; 
			myObjects[i+1] = myTmp; 
			myArrayIsSorted = false;
			}
	} // i
} // while
if (myNumberOfLockedFrames == 1) { // myNumberOfLockedFrames == 1
	if (myObjects[0].locked == true) myTopY = myObjects[0].geometricBounds[2]; // отсчет от нижней кромки фрейма до низа страницы
	else myBottomY = myObjects[myObjects.length - 1].geometricBounds[0]; // отсчет от верха страницы до верхней кромки фрейма
	} // myNumberOfLockedFrames == 1
if (myNumberOfLockedFrames == 2) { // myNumberOfLockedFrames == 2
	if ((myObjects[0].locked != true) || (myObjects[myObjects.length - 1].locked != true)) {alert ("Этот скрипт предполагает, что если есть два непремещаемых фрейма, то это должы быть самый верхний и самый нижний.\nВ данном случае это правило не выполнено."); exit();}
	myTopY = myObjects[0].geometricBounds[2];
	myBottomY = myObjects[myObjects.length - 1].geometricBounds[0];
	} // myNumberOfLockedFrames == 2
for (i = 0; i < myObjects.length -1; i++) { // i
	if ((myObjects[i].geometricBounds[2] >= myObjects[i + 1].geometricBounds[0]))  {alert ("Фреймы не должны касаться или перекрываться."); exit();}
	} // i
mySpace = myBottomY - myTopY;
if (myNumberOfLockedFrames == 0) { // myNumberOfLockedFrames == 0
for (j = 0; j < myObjects.length; j++) { // j
	var myObjHeight = myObjects[j].geometricBounds[2] - myObjects[j].geometricBounds[0];
	myHeights.push(myObjHeight);
	mySpace -= myObjHeight;
	} // j
} // myNumberOfLockedFrames == 0
if (myNumberOfLockedFrames == 1) { // myNumberOfLockedFrames == 1
for (j = 0; j < myObjects.length; j++) { // j
	var myObjHeight = myObjects[j].geometricBounds[2] - myObjects[j].geometricBounds[0];
	myHeights.push(myObjHeight);
	if (j == 0) continue; // высота первого зафиксированного фрейма в вычислениях не участвует
	mySpace -= myObjHeight;
	} // j
} // myNumberOfLockedFrames == 1
if (myNumberOfLockedFrames == 2) { // myNumberOfLockedFrames == 2
for (j = 0; j < myObjects.length-1; j++) { // j
	// минус один в предыдущей строке -- чтобы исключить учет размеров последнего фрейма при вычислении величины свободного пространства
	var myObjHeight = myObjects[j].geometricBounds[2] - myObjects[j].geometricBounds[0];
	myHeights.push(myObjHeight);
	if (j == 0) continue; // высота первого зафиксированного фрейма в вычислениях не участвует
	mySpace -= myObjHeight;
	} // j
} // myNumberOfLockedFrames == 2
// определим, на сколько единиц ряда Фибоначчи можно разделить свободное пространство.
for (k = 0; k < myObjects.length+1 - myNumberOfLockedFrames; k++) { // k
	 //  в операнде "myObjects.length+1 - myNumberOfLockedFrames" поправка "+1" обусловлена тем, что если в выборке нет зафиксированных фреймов, то свободных пространств всегда на единицу больше, чем число выделенных объектов.
	 //  а поправка '- myNumberOfLockedFrames' в этом операнде обусловлена тем, что в случае, если зафиксирован один фрейм, то число свободных полей уменьшается на один, а если зафиксированы фреймы сверху и снизу — то на два
	myNumderOfUnits += myFibNums[k];
	} // k
// определим размер этой единицы
myUnit = mySpace/myNumderOfUnits;

if (myNumberOfLockedFrames == 0) { // myNumberOfLockedFrames == 0
	// Расчет Y-координат самого верхнего выделенного фрейма
	myX0 = myObjects[0].geometricBounds[1];
	myX1 = myObjects[0].geometricBounds[3];
	myY0 = myTopY + myFibNums[0] * myUnit;
	myY1 = myY0 + myHeights[0];
	myObjects[0].geometricBounds = [myY0,myX0,myY1,myX1];
for (k = 1; k < myObjects.length; k++) { // k
	myX0 = myObjects[k].geometricBounds[1];
	myX1 = myObjects[k].geometricBounds[3];
	myY0 = myObjects[k-1].geometricBounds[2] + myFibNums[k] * myUnit;
	myY1= myY0 + myHeights[k];
	myObjects[k].geometricBounds = [myY0,myX0,myY1,myX1];
} // k
} // myNumberOfLockedFrames == 0

// зафиксирован верхний фрейм
if (myNumberOfLockedFrames == 1 && myObjects[0].locked == true) { // myNumberOfLockedFrames == 1 (в.ф.)
for (k = 1; k < myObjects.length; k++) { // k
	myX0 = myObjects[k].geometricBounds[1];
	myX1 = myObjects[k].geometricBounds[3];
	myY0 = myObjects[k-1].geometricBounds[2] + myFibNums[k-1] * myUnit;
	myY1= myY0 + myHeights[k];
	myObjects[k].geometricBounds = [myY0,myX0,myY1,myX1];
} // k
} // myNumberOfLockedFrames == 1(в.ф.)

// зафиксирован нижний фрейм
if (myNumberOfLockedFrames == 1 && myObjects[0].locked != true) { // myNumberOfLockedFrames == 1 (н.ф.)
	// Расчет Y-координат самого верхнего выделенного фрейма
	myX0 = myObjects[0].geometricBounds[1];
	myX1 = myObjects[0].geometricBounds[3];
	myY0 = myTopY + myFibNums[0] * myUnit;
	myY1 = myY0 + myHeights[0];
	myObjects[0].geometricBounds = [myY0,myX0,myY1,myX1];
for (k = 1; k < myObjects.length-1; k++) { // k
	myX0 = myObjects[k].geometricBounds[1];
	myX1 = myObjects[k].geometricBounds[3];
	myY0 = myObjects[k-1].geometricBounds[2] + myFibNums[k] * myUnit;
	myY1= myY0 + myHeights[k];
	myObjects[k].geometricBounds = [myY0,myX0,myY1,myX1];
} // k
} // myNumberOfLockedFrames == 1(н.ф.)

if (myNumberOfLockedFrames == 2) { // myNumberOfLockedFrames == 2
for (k = 1; k < myObjects.length-1; k++) { // k
	myX0 = myObjects[k].geometricBounds[1];
	myX1 = myObjects[k].geometricBounds[3];
	myY0 = myObjects[k-1].geometricBounds[2] + myFibNums[k-1] * myUnit;
	myY1= myY0 + myHeights[k];
	myObjects[k].geometricBounds = [myY0,myX0,myY1,myX1];
} // k
} // myNumberOfLockedFrames == 2
//alert ("Готово!");
exit();
